create table NNIMPORT(
CODE VARCHAR2(20 CHAR) NOT NULL,
DESCRIPTION VARCHAR2(200 CHAR) NOT NULL,
DATA_TYPE VARCHAR2(10 CHAR) NOT NULL,
TABLE_NAME VARCHAR2(100 CHAR) NOT NULL,
CONSTRAINT PK_NNIMPORT PRIMARY KEY(CODE)
)
;

create table NNIMPORT_COLUMNS(
ID NUMBER NOT NULL,
NNIMPORT_CODE VARCHAR2(20 CHAR) NOT NULL,
COLUMN_NAME VARCHAR2(200 CHAR) NOT NULL,
IS_COL_PK VARCHAR2(1 CHAR),
DATA_POSITION NUMBER NOT NULL,
DATA_LENGTH NUMBER,

CONSTRAINT PK_NNIMPORT_COLUMNS PRIMARY KEY (ID)
)
;

CREATE SEQUENCE NNIMPORT_COLUMNS_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE
;

ALTER TABLE NNIMPORT_COLUMNS
  ADD DATA_TYPE VARCHAR2(1 CHAR)
;

ALTER TABLE NNIMPORT_COLUMNS
  ADD DEFAULT_VALUE VARCHAR2(100 CHAR)
;

INSERT INTO NNIMPORT (CODE, DESCRIPTION, DATA_TYPE, TABLE_NAME)
values
('MMP', 'Mercury Marine pricelist', 'ASCII', 'S_ARTIKLI');

INSERT INTO NNIMPORT_COLUMNS (ID, NNIMPORT_CODE, COLUMN_NAME, IS_COL_PK, DATA_POSITION, DATA_LENGTH, DATA_TYPE, DEFAULT_VALUE)
values
(NNIMPORT_COLUMNS_SEQ.NEXTVAL, 'MMP', 'SIFRA_DOB', 'Y', 5, 9, 'S', null);

INSERT INTO NNIMPORT_COLUMNS (ID, NNIMPORT_CODE, COLUMN_NAME, IS_COL_PK, DATA_POSITION, DATA_LENGTH, DATA_TYPE, DEFAULT_VALUE)
values
(NNIMPORT_COLUMNS_SEQ.NEXTVAL, 'MMP', 'NAZIV', 'N', 5, 9, 'S', null);

INSERT INTO NNIMPORT_COLUMNS (ID, NNIMPORT_CODE, COLUMN_NAME, IS_COL_PK, DATA_POSITION, DATA_LENGTH, DATA_TYPE, DEFAULT_VALUE)
values
(NNIMPORT_COLUMNS_SEQ.NEXTVAL, 'MMP', 'NAZIV1', 'N', 27, 17, 'S', null);

INSERT INTO NNIMPORT_COLUMNS (ID, NNIMPORT_CODE, COLUMN_NAME, IS_COL_PK, DATA_POSITION, DATA_LENGTH, DATA_TYPE, DEFAULT_VALUE)
values
(NNIMPORT_COLUMNS_SEQ.NEXTVAL, 'MMP', 'CENA_SKL', 'N', 81, 9, 'N', '0');

INSERT INTO NNIMPORT_COLUMNS (ID, NNIMPORT_CODE, COLUMN_NAME, IS_COL_PK, DATA_POSITION, DATA_LENGTH, DATA_TYPE, DEFAULT_VALUE)
values
(NNIMPORT_COLUMNS_SEQ.NEXTVAL, 'MMP', 'ID_ENOTA', 'N', 0, 0, 'S', 'KS');

INSERT INTO NNIMPORT_COLUMNS (ID, NNIMPORT_CODE, COLUMN_NAME, IS_COL_PK, DATA_POSITION, DATA_LENGTH, DATA_TYPE, DEFAULT_VALUE)
values
(NNIMPORT_COLUMNS_SEQ.NEXTVAL, 'MMP', 'ID_DAVEK', 'N', 0, 0, 'L', '3');

INSERT INTO NNIMPORT_COLUMNS (ID, NNIMPORT_CODE, COLUMN_NAME, IS_COL_PK, DATA_POSITION, DATA_LENGTH, DATA_TYPE, DEFAULT_VALUE)
values
(NNIMPORT_COLUMNS_SEQ.NEXTVAL, 'MMP', 'STOCKS', 'N', 0, 0, 'S', 'Y');

INSERT INTO NNIMPORT_COLUMNS (ID, NNIMPORT_CODE, COLUMN_NAME, IS_COL_PK, DATA_POSITION, DATA_LENGTH, DATA_TYPE, DEFAULT_VALUE)
values
(NNIMPORT_COLUMNS_SEQ.NEXTVAL, 'MMP', 'VRSTA', 'N', 0, 0, 'S', 'A');

INSERT INTO NNIMPORT_COLUMNS (ID, NNIMPORT_CODE, COLUMN_NAME, IS_COL_PK, DATA_POSITION, DATA_LENGTH, DATA_TYPE, DEFAULT_VALUE)
values
(NNIMPORT_COLUMNS_SEQ.NEXTVAL, 'MMP', 'V_UPORABI', 'N', 0, 0, 'S', 'Y');

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1256, SYSDATE, '5.5', 1176, 'Import')
;

