ALTER TABLE M_POGODBE
ADD ID_PRIVEZ NUMBER;

UPDATE M_POGODBE M
SET M.ID_PRIVEZ = (SELECT N.ID_PRIVEZ FROM NNPRIVEZ N WHERE N.OBJEKT = M.OBJEKT AND N.N_PRIVEZA = M.N_PRIVEZA)
WHERE M.ID_PRIVEZ IS NULL;

DROP VIEW V_POGODBE;

CREATE OR REPLACE VIEW V_POGODBE AS (
	SELECT P.ID_POGODBE AS V_POGODBE_ID, P.ID_POGODBE, P.ID_LASTNIKA, P.ID_PLOVILA, P.ID_MASTER, P.OBJEKT, P.N_PRIVEZA, P.N_POGODBE, P.DATUM_ZACETKA, P.DATUM_KONCA, P.PREDVIDENI_DATUM_KONCA, P.DATUM_KREIRANJA, P.USER_KREIRANJA,
  P.DATUM_SPREMEMBE, P.USER_SPREMEMBE, P.STATUS, P.DATUM_SKLENITVE, P.DATUM_PREKINITVE, P.KOMENTAR, P.TIP_POGODBE, P.EXTENSION_SEQUENCE_NUMBER, P.EXTENSION_DATE, P.ID_PRIVEZ,
  NNSTAT.OPIS AS STATUS_OPIS, NNSTAT.INTERNI_OPIS AS STATUS_INTERNI_OPIS,
  KUPVRS.VRSTA AS CURRENT_KUPCI_VRSTA, PLOV.IME AS PLOVILA_IME, PLOV.PODALJSA AS PLOVILA_PODALJSA, KUP.IME AS KUPCI_IME, KUP.PRIIMEK AS KUPCI_PRIIMEK,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KUP.IME || ' ' || KUP.PRIIMEK) ELSE (KUP.PRIIMEK || ' ' || KUP.IME) END) AS OWNER,
  NP.ID_PRIVEZ AS NNPRIVEZ_ID_PRIVEZ, NP.KATEGORIJA AS NNPRIVEZ_KATEGORIJA, NP.OBJEKT AS NNPRIVEZ_OBJEKT, NP.N_PRIVEZA AS NNPRIVEZ_PRIVEZ, NO.STORAGE AS NNOBJEKT_STORAGE, NNLOC.ID AS NNLOCATION_ID
	FROM M_POGODBE P
	LEFT OUTER JOIN NNSTATPOG NNSTAT ON P.STATUS = NNSTAT.SIFRA
  LEFT OUTER JOIN PLOVILA PLOV ON PLOV.ID = P.ID_PLOVILA
  LEFT OUTER JOIN KUPCI KUP ON KUP.ID = P.ID_LASTNIKA
  LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = P.ID_PRIVEZ
  LEFT OUTER JOIN NNOBJEKT NO ON NO.SIFRA = NP.OBJEKT 
  LEFT OUTER JOIN NNPOMOL NPOM ON NPOM.SIFRA = NP.KATEGORIJA
  LEFT OUTER JOIN NNLOCATION NNLOC ON NNLOC.ID = NPOM.NNLOCATION_ID
  LEFT OUTER JOIN (SELECT KUPCI_VRSTA.*, RANK() OVER (PARTITION BY ID_KUPCA ORDER BY ID_KUPCI_VRSTA DESC) RNK FROM KUPCI_VRSTA) KUPVRS ON (KUPVRS.ID_KUPCA = P.ID_LASTNIKA AND KUPVRS.RNK = 1)
);

CREATE OR REPLACE
TRIGGER M_POGODBE_ID_PRIVEZ_TRG
BEFORE INSERT
ON M_POGODBE
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
	IF (:NEW.ID_PRIVEZ IS NULL AND :NEW.N_PRIVEZA IS NOT NULL AND :NEW.OBJEKT IS NOT NULL) THEN
          SELECT ID_PRIVEZ INTO :NEW.ID_PRIVEZ FROM NNPRIVEZ WHERE N_PRIVEZA = :NEW.N_PRIVEZA AND OBJEKT = :NEW.OBJEKT;;
	END IF;;
    EXCEPTION
    WHEN NO_DATA_FOUND THEN
        :NEW.ID_PRIVEZ := NULL;;
END;;
;

ALTER TABLE PREGLEDI
ADD ID_PRIVEZ NUMBER;

UPDATE PREGLEDI P
SET P.ID_PRIVEZ = (SELECT N.ID_PRIVEZ FROM NNPRIVEZ N WHERE N.OBJEKT = P.OBJEKT AND N.N_PRIVEZA = P.N_PRIVEZA)
WHERE P.ID_PRIVEZ IS NULL;

DROP VIEW V_PREGLEDI;

CREATE OR REPLACE VIEW V_PREGLEDI AS (
  SELECT P.ID_PREGLEDI, P.ID_LASTNIKA, P.ID_PLOVILA, P.NSTANJE, P.DATUM, P.CAS, P.KOMENTAR, P.KOMENTAR1, P.USER_KREIRANJA, P.LASTNIK_OBVESCEN, P.N_PRIVEZA, P.OBJEKT, P.ID_STORITVE, P.STATUS,
  PL.IME AS PLOVILA_IME, NS.OPIS AS NSTANJE_OPIS, NS.INTERNI_OPIS AS NSTANJE_INTERNI_OPIS, NS.NSTANJE_TYPE AS NSTANJE_TYPE, NNP.NNLOCATION_ID, KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK,
  (CASE WHEN P.ID_PRIVEZ IS NOT NULL THEN NP.OBJEKT ELSE P.OBJEKT END) AS NNPRIVEZ_OBJEKT, (CASE WHEN P.ID_PRIVEZ IS NOT NULL THEN NP.N_PRIVEZA ELSE P.N_PRIVEZA END) AS NNPRIVEZ_PRIVEZ,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KU.IME || ' ' || KU.PRIIMEK) ELSE (KU.PRIIMEK || ' ' || KU.IME) END) AS OWNER
	FROM PREGLEDI P
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = P.ID_PLOVILA
  LEFT OUTER JOIN KUPCI KU ON KU.ID = P.ID_LASTNIKA
  LEFT OUTER JOIN NSTANJE NS ON NS.NSTANJE = P.NSTANJE
  LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = P.ID_PRIVEZ
  LEFT OUTER JOIN NNPOMOL NNP ON NNP.SIFRA = NP.KATEGORIJA
);

CREATE OR REPLACE
TRIGGER PREGLEDI_ID_PRIVEZ_TRG
BEFORE INSERT
ON PREGLEDI
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
	IF (:NEW.ID_PRIVEZ IS NULL AND :NEW.N_PRIVEZA IS NOT NULL AND :NEW.OBJEKT IS NOT NULL) THEN
      SELECT ID_PRIVEZ INTO :NEW.ID_PRIVEZ FROM NNPRIVEZ WHERE N_PRIVEZA = :NEW.N_PRIVEZA AND OBJEKT = :NEW.OBJEKT;;
	END IF;;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
        :NEW.ID_PRIVEZ := NULL;;
END;;
;

ALTER TABLE DOGODKI
ADD ID_PRIVEZ NUMBER;

UPDATE DOGODKI D
SET D.ID_PRIVEZ = (SELECT N.ID_PRIVEZ FROM NNPRIVEZ N WHERE N.OBJEKT = D.OBJEKT AND N.N_PRIVEZA = D.N_PRIVEZA)
WHERE D.ID_PRIVEZ IS NULL;

DROP VIEW V_DOGODKI;

CREATE OR REPLACE VIEW V_DOGODKI AS (
  SELECT D.ID, D.ID_LASTNIKA, D.ID_PLOVILA, D.DATUM_ZACETKA, D.KATEGORIJA_DOGODKA, D.LAST_PORT, D.OBJEKT, D.N_PRIVEZA, D.STORITEV, D.N_POGODBE, D.PREDVIDENI_DATUM_KONCA, D.DATUM_KONCA, 
  D.DATUM_KREIRANJA, D.USER_KREIRANJA, D.DATUM_SPREMEMBE, D.USER_SPREMEMBE, D.ID_RFID_DATA, D.DAILY, D.ID_PRIVEZ_FROM, D.ID_PRIVEZ, 
  ND.OPIS AS NDOGODEK_OPIS, ND.INTERNI_OPIS AS NDOGODEK_INTERNI_OPIS,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, P.IME AS PLOVILA_IME, P.POGODBENA_N_PRIVEZA, VP.NNLOCATION_ID AS NNLOCATION_ID, 
  (CASE WHEN D.ID_PRIVEZ IS NOT NULL THEN NP.OBJEKT ELSE D.OBJEKT END) AS NNPRIVEZ_OBJEKT, (CASE WHEN D.ID_PRIVEZ IS NOT NULL THEN NP.N_PRIVEZA ELSE D.N_PRIVEZA END) AS NNPRIVEZ_PRIVEZ,
  NP_FROM.OBJEKT AS NNPRIVEZ_FROM_OBJEKT, NP_FROM.N_PRIVEZA AS NNPRIVEZ_FROM_PRIVEZ, VP_FROM.NNLOCATION_ID AS NNLOCATION_ID_FROM
	FROM DOGODKI D
  LEFT OUTER JOIN NDOGODEK ND ON ND.NDOGODEK = D.KATEGORIJA_DOGODKA
  LEFT OUTER JOIN KUPCI K ON K.ID = D.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA P ON P.ID = D.ID_PLOVILA
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = D.ID_PRIVEZ
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VP_FROM ON VP_FROM.ID_PRIVEZ = D.ID_PRIVEZ_FROM
  LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = D.ID_PRIVEZ
  LEFT OUTER JOIN NNPRIVEZ NP_FROM ON NP_FROM.ID_PRIVEZ = D.ID_PRIVEZ_FROM
);


CREATE OR REPLACE
TRIGGER DOGODKI_ID_PRIVEZ_TRG
BEFORE INSERT
ON DOGODKI
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
	IF (:NEW.ID_PRIVEZ IS NULL AND :NEW.N_PRIVEZA IS NOT NULL AND :NEW.OBJEKT IS NOT NULL) THEN
      SELECT ID_PRIVEZ INTO :NEW.ID_PRIVEZ FROM NNPRIVEZ WHERE N_PRIVEZA = :NEW.N_PRIVEZA AND OBJEKT = :NEW.OBJEKT;;
	END IF;;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
        :NEW.ID_PRIVEZ := NULL;;
END;;
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1430, SYSDATE, '5.5', 1350, 'IdPrivez')
;