CREATE OR REPLACE VIEW V_PLS_READING (ID, PLS_READING_ID, PLS_METER_ID, ID_PRIVEZ, DT_READ_START, VALUE_START, DT_READ_END, VALUE_END, METER_NAME, NPRIKLJ_SIFRA, AMPERAGE,
    PHASE_COUNT, IP, PORT, DEVICE_ADDRESS, METER_NUMBER, N_PRIVEZA, NPRIKLJ_INTERNI_OPIS, NPRIKLJ_OPIS, LAST_STATUS_UPDATE_DT, LAST_VALUE, LAST_ONLINE_STATUS, LAST_LOCK_STATUS,
    LAST_VERSION, OWNER_NAME, VESSEL_NAME, ACTIVE, ID_ENOTA, CONV_FACTOR, ENOTA_INTERNI_OPIS, INITIAL_STATE, INITIAL_STATE_START, INITIAL_STATE_END, METER_CONV_FACTOR) AS
SELECT
    M.PLS_METER_ID AS ID,
    R.PLS_READING_ID,
    M.PLS_METER_ID,
    R.ID_PRIVEZ,
    R.DT_READ_START,
    R.VALUE_START,
    R.DT_READ_END,
    R.VALUE_END,
    M.NAME AS METER_NAME,
    M.NPRIKLJ_SIFRA,
    M.AMPERAGE,
    M.PHASE_COUNT,
    M.IP,
    M.PORT,
    M.DEVICE_ADDRESS,
    M.METER_NUMBER,
    P.N_PRIVEZA,
    VP.INTERNI_OPIS AS NPRIKLJ_INTERNI_OPIS,
    VP.OPIS AS NPRIKLJ_OPIS,
    MS.DT_READ AS LAST_STATUS_UPDATE_DT,
    MS.VALUE AS LAST_VALUE,
    MS.ONLINE_STATUS AS LAST_ONLINE_STATUS,
    MS.LOCK_STATUS AS LAST_LOCK_STATUS,
    MS.VERSION AS LAST_VERSION,
    (CASE WHEN R.ID_LASTNIKA IS NOT NULL THEN ((CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END)) ELSE NULL END) AS OWNER_NAME,
    PL.IME AS VESSEL_NAME,
    M.ACTIVE,
    M.ID_ENOTA,
    R.CONV_FACTOR,
    ENT.INTERNI_OPIS AS ENOTA_INTERNI_OPIS,
    M.INITIAL_STATE,
    R.INITIAL_STATE_START,
    R.INITIAL_STATE_END,
    M.CONV_FACTOR AS METER_CONV_FACTOR
FROM
    PLS_METER M
    LEFT OUTER JOIN PLS_READING R ON R.PLS_READING_ID = M.ACTIVE_PLS_READING_ID
    LEFT OUTER JOIN NNPRIVEZ P ON P.ID_PRIVEZ = R.ID_PRIVEZ
    LEFT OUTER JOIN NPRIKLJ VP ON VP.SIFRA = M.NPRIKLJ_SIFRA
    LEFT OUTER JOIN PLS_METER_STATUS MS ON MS.PLS_METER_STATUS_ID = M.LAST_PLS_METER_STATUS_ID
    LEFT OUTER JOIN KUPCI K ON K.ID = R.ID_LASTNIKA
    LEFT OUTER JOIN PLOVILA PL ON PL.ID = R.ID_PLOVILA
    LEFT OUTER JOIN S_ENOTE ENT ON ENT.ID_ENOTA = M.ID_ENOTA
;

CREATE OR REPLACE VIEW V_PLS_READING_EXP (ID, PLS_READING_ID, PLS_METER_ID, ID_PRIVEZ, DT_READ_START, VALUE_START, DT_READ_END, VALUE_END, METER_NAME, NPRIKLJ_SIFRA, AMPERAGE,
    PHASE_COUNT, IP, PORT, DEVICE_ADDRESS, METER_NUMBER, N_PRIVEZA, NPRIKLJ_INTERNI_OPIS, NPRIKLJ_OPIS, LAST_STATUS_UPDATE_DT, LAST_VALUE, LAST_ONLINE_STATUS, LAST_LOCK_STATUS,
    LAST_VERSION, OWNER_NAME, VESSEL_NAME, ACTIVE, ID_ENOTA, CONV_FACTOR, ENOTA_INTERNI_OPIS, INITIAL_STATE, INITIAL_STATE_START, INITIAL_STATE_END, METER_CONV_FACTOR) AS
SELECT
    R.PLS_READING_ID AS ID,
    R.PLS_READING_ID,
    M.PLS_METER_ID,
    R.ID_PRIVEZ,
    R.DT_READ_START,
    R.VALUE_START,
    R.DT_READ_END,
    R.VALUE_END,
    M.NAME AS METER_NAME,
    M.NPRIKLJ_SIFRA,
    M.AMPERAGE,
    M.PHASE_COUNT,
    M.IP,
    M.PORT,
    M.DEVICE_ADDRESS,
    M.METER_NUMBER,
    P.N_PRIVEZA,
    VP.INTERNI_OPIS AS NPRIKLJ_INTERNI_OPIS,
    VP.OPIS AS NPRIKLJ_OPIS,
    MS.DT_READ AS LAST_STATUS_UPDATE_DT,
    MS.VALUE AS LAST_VALUE,
    MS.ONLINE_STATUS AS LAST_ONLINE_STATUS,
    MS.LOCK_STATUS AS LAST_LOCK_STATUS,
    MS.VERSION AS LAST_VERSION,
    (CASE WHEN R.ID_LASTNIKA IS NOT NULL THEN ((CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END)) ELSE NULL END) AS OWNER_NAME,
    PL.IME AS VESSEL_NAME,
    M.ACTIVE,
    M.ID_ENOTA,
    R.CONV_FACTOR,
    ENT.INTERNI_OPIS AS ENOTA_INTERNI_OPIS,
    M.INITIAL_STATE,
    R.INITIAL_STATE_START,
    R.INITIAL_STATE_END,
    M.CONV_FACTOR AS METER_CONV_FACTOR
FROM
    PLS_READING R
    JOIN PLS_METER M ON M.PLS_METER_ID = R.PLS_METER_ID
    LEFT OUTER JOIN NNPRIVEZ P ON P.ID_PRIVEZ = R.ID_PRIVEZ
    LEFT OUTER JOIN NPRIKLJ VP ON VP.SIFRA = M.NPRIKLJ_SIFRA
    LEFT OUTER JOIN PLS_METER_STATUS MS ON MS.PLS_METER_STATUS_ID = M.LAST_PLS_METER_STATUS_ID
    LEFT OUTER JOIN KUPCI K ON K.ID = R.ID_LASTNIKA
    LEFT OUTER JOIN PLOVILA PL ON PL.ID = R.ID_PLOVILA
    LEFT OUTER JOIN S_ENOTE ENT ON ENT.ID_ENOTA = M.ID_ENOTA
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1926, SYSDATE, '5.5', 1846, 'PULS')
;
