CREATE OR REPLACE VIEW V_FB_LOCATION
AS (
SELECT FL.ID_FB_LOCATION, FL.DESCRIPTION, FL.ACTIVE, FL.NNLOCATION_ID, FL.REGISTER_NR, FL.QUICK_ORDER,
FT.DESCRIPTION AS TABLE_DESCRIPTION, SL.NAZIV AS LOKACIJA_NAZIV, PDO.NAME AS PRINT_DEVICE_ORDER, PDI.NAME AS PRINT_DEVICE_INVOICE, PMO.OPIS AS PRINT_MODULE_ORDER, 
NC.OPIS AS PROFIT_CENTER_DESCRIPTION, WS.DESCRIPTION AS WORKSTATION_DESCRIPTION
FROM FB_LOCATION FL
LEFT OUTER JOIN S_LOKACIJE SL ON SL.ID_LOKACIJA = FL.ID_LOKACIJA
LEFT OUTER JOIN FB_TABLE FT ON FT.ID_FB_TABLE = FL.ID_FB_TABLE
LEFT OUTER JOIN PRINT_DEVICE PDO ON PDO.ID_PRINT_DEVICE = FL.ID_PRINT_DEVICE_ORDER
LEFT OUTER JOIN PRINT_DEVICE PDI ON PDI.ID_PRINT_DEVICE = FL.ID_PRINT_DEVICE_INVOICE
LEFT OUTER JOIN PRINT_MODULI PMO ON PMO.MODULE_ID = FL.ID_PRINT_MODULE_ORDER
LEFT OUTER JOIN NNPC NC ON NC.SIFRA = FL.PROFIT_CENTER
LEFT OUTER JOIN WORKSTATION WS ON WS.ID = FL.ID_WORKSTATION
);

CREATE OR REPLACE VIEW V_S_GRUPE
AS (
SELECT SG.ID_GRUPA, SG.NAZIV, SG.INTERNI_OPIS, SG.ID_LOKACIJE, SG.NNLOCATION_ID, SG.SORT, SG.QUICK_SELECTION, SG.GROUP_NUMBER, SG.ROUNDING,
SL.NAZIV AS WAREHOUSE_NAME, VK.OPIS AS OWNER_TYPE_DESCRIPTION, MS.OPIS AS SERVICE_DESCRIPTION, SC.OPIS AS CATEGORY_DESCRIPTION, FBP.DESCRIPTION AS FB_LOCATION_PREPARE
FROM S_GRUPE SG
LEFT OUTER JOIN S_LOKACIJE SL ON SL.ID_LOKACIJA = SG.ID_LOKACIJE
LEFT OUTER JOIN NNVRSKUP VK ON VK.SIFRA = SG.OWNER_TYPE
LEFT OUTER JOIN M_NNSTOMAR MS ON MS.SIFRA = SG.SERVICE
LEFT OUTER JOIN S_CATEGORY SC ON SC.ID_CATEGORY = SG.ID_CATEGORY
LEFT OUTER JOIN FB_LOCATION FBP ON FBP.ID_FB_LOCATION = SG.ID_FB_LOCATION_PREPARE
);

DROP VIEW V_FB_TABLE;

CREATE OR REPLACE VIEW V_FB_TABLE AS (
SELECT FT.ID_FB_TABLE, FT.ID_FB_LOCATION, FT.DESCRIPTION, FT.CAPACITY, FT.ACTIVE, FT.NNLOCATION_ID AS NNLOCATION_ID, FT.MULTIPLE_OPEN_ORDERS, 
FL.DESCRIPTION AS LOCATION_DESCRIPTION
FROM FB_TABLE FT
LEFT OUTER JOIN FB_LOCATION FL ON FL.ID_FB_LOCATION = FT.ID_FB_LOCATION
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2078, SYSDATE, '5.5', 1998, 'Viewi')
;
