DROP VIEW V_RACUN_DATA;

CREATE OR REPLACE VIEW V_RACUN_DATA AS (
  SELECT R.ID_RACUN_DATA, R.N_RACUNA, R.KOLICINA, R.ZN_DAVKA, R.CENABD, R.ZNESEK, R.ID_OBRACUN, R.ID_STORITVE, R.ID_SALDKONT, R.ZAP_ST, R.POPUST, R.DAV_STOPNJA, R.STORNO, 
  R.ST_DN, R.RN_TEKST, R.AVT_FAKT, R.NETO, R.NON_REFUND, R.TIP, R.ID_STORITVE_GEN, R.DEPOSIT_AMOUNT, R.DATUM_OD, R.DATUM_DO, R.KOMENTAR, R.PAYMENT, R.ID_DAVEK,
  S.ZA_PLACILO AS SALDKONT_ZA_PLACILO, S.PORABLJENO AS SALDKONT_PORABLJENO, S.ZNESEK AS SALDKONT_ZNESEK, S.ID_KUPCA AS SALDKONT_ID_KUPCA, S.ID_PLOVILA AS SALDKONT_ID_PLOVILA, 
  S.TECAJ_VALUTE AS SALDKONT_TECAJ_VALUTE,S.TECAJ_PRERACUN AS SALDKONT_TECAJ_PRERACUN, S.VALUTA_RN AS SALDKONT_VALUTA_RN, S.STOAK AS SALDKONT_STOAK, S.N_RACUNA AS SALDKONT_N_RACUNA, S.DATUM AS SALDKONT_DATUM,
  S.DATUM_VALUTACIJE AS SALDKONT_DATUM_VALUTACIJE, S.SDK_RN_PL AS SALDKONT_SDK_RN_PL, S.SDK_RN_TIP AS SALDKONT_SDK_RN_TIP, S.NNLOCATION_ID AS SALDKONT_NNLOCATION_ID, S.R_EXPORT_NR AS SALDKONT_EXPORT_NR,
  K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.EMAIL AS KUPCI_EMAIL, K.NASLOV AS KUPCI_NASLOV, K.MESTO AS KUPCI_MESTO, K.POSTA AS KUPCI_POSTA, K.NDRZAVA AS KUPCI_NDRZAVA, ND.OPIS AS KUPCI_DRZAVA_OPIS,
  NK.SLO AS KNJIZBA_OPIS, SD.OPIS AS DAVEK_OPIS, SO.ID_ARTIKEL AS OBRACUN_ID_ARTIKEL, SO.OPIS AS OBRACUN_OPIS, SO.KOLICINA AS OBRACUN_KOLICINA, SE.NAZIV AS OBRACUN_ENOTA_NAZIV, SE.OSN_ENOTA AS OBRACUN_ENOTA_OSN_ENOTA,
  M.STORITEV AS STORITVE_STORITEV, M.NCARD AS STORITVE_NCARD, SD.EXT_ID AS DAVEK_EXT_ID,
  N.OPIS AS NNSTOMAR_OPIS, N.INTERNI_OPIS AS NNSTOMAR_INTERNI_OPIS, N.TRIGGER_DEPOSIT AS NNSTOMAR_TRIGGER_DEPOSIT, NE.OPIS AS NNSTOMAR_ENOTA_OPIS,
  N.NGRUPA AS NNSTOMAR_NGRUPA, SA.ID_GRUPA AS ARTIKLI_ID_GRUPA,
  (CASE WHEN SO.OPIS IS NOT NULL THEN SO.OPIS ELSE (CASE WHEN N.OPIS IS NOT NULL THEN N.OPIS ELSE NK.SLO END) END) AS TITLE,
  (CASE WHEN SO.OPIS IS NOT NULL THEN SO.OPIS ELSE (CASE WHEN N.INTERNI_OPIS IS NOT NULL THEN N.INTERNI_OPIS ELSE NK.INTERNI_OPIS END) END) AS INTERNAL_TITLE,
  (SELECT SUM(NVL(ZN_DAVKA, 0)) FROM RACUN_DATA WHERE ID_SALDKONT = R.ID_SALDKONT) AS ZN_DAVKA_SUM
	FROM RACUN_DATA R
  LEFT OUTER JOIN SALDKONT S ON S.ID_SALDKONT = R.ID_SALDKONT
  LEFT OUTER JOIN NKNJIZBA NK ON NK.SALDKONT = S.VRSTA_RACUNA
  LEFT OUTER JOIN KUPCI K ON K.ID = S.ID_KUPCA
  LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = K.NDRZAVA
  LEFT OUTER JOIN S_DAVEK SD ON SD.ID_DAVEK = R.ID_DAVEK
  LEFT OUTER JOIN S_OBRACUN SO ON SO.ID_OBRACUN = R.ID_OBRACUN
  LEFT OUTER JOIN S_ARTIKLI SA ON SO.ID_ARTIKEL = SA.ID_ARTIKEL
  LEFT OUTER JOIN S_ENOTE SE ON SE.ID_ENOTA = SO.ID_ENOTA
  LEFT OUTER JOIN M_STORITVE M ON M.ID_STORITVE = R.ID_STORITVE
  LEFT OUTER JOIN M_NNSTOMAR N ON N.SIFRA = M.STORITEV
  LEFT OUTER JOIN NNENOTE NE ON NE.SIFRA = ENOTA
)
;

ALTER TABLE BOOKKEEPING_RULES
ADD PROFIT_CENTER VARCHAR2(30 CHAR)
;

INSERT INTO MARINA_SEQUENCES (TABLENAME, FIELDNAME, SEQUENCE_NAME, COUNTER_TYPE)
VALUES ('KNJIZBE', 'CTRL', 'KNJIZBE_SEQ', 'S_KLJUCI')
;

INSERT INTO MARINA_SEQUENCES (TABLENAME, FIELDNAME, SEQUENCE_NAME, COUNTER_TYPE)
VALUES ('NKNJIZBA', 'NKNJIZBA', 'NKNJIZBA_SEQ', 'S_KLJUCI')
;

DROP VIEW V_KNJIZBE;

CREATE OR REPLACE VIEW V_KNJIZBE AS(
SELECT KN.CTRL, KN.IDMASTER, KN.PARTNER, KN.KONTO, KN.STRAN, KN.BZNESEK, KN.DZNESEK, KN.BZNESEKSIT, KN.DZNESEKSIT, KN.ID_SALDKONT, KN.TIPKNJ, KN.DATUMK, KN.DATUMV, KN.TEKST, KN.RAZMEJITEV, KN.PROCENT_DAVKA, KN.VRSTA_KNJ, KN.IDGROUP, 
KN.R_EXPORT_NR, KN.NNLOCATION_ID, KN.ID_VOUCHER, KN.VER, KN.PROFIT_CENTER, RD.ZN_DAVKA, KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK, KU.INT_CODE AS KUPCI_INT_CODE, KU.N_KK AS KUPCI_NKK, 
SF.CTRL AS SIFKONT_CTRL, SF.OZNAKA AS SIFKONT_OZNAKA, SF.NAZIV AS SIFKONT_NAZIV, SF.DELOVNA_GRUPA AS SIFKONT_DELOVNA_GRUPA,
NS.OPIS AS NNSTOMAR_OPIS, NS.INTERNI_OPIS AS NNSTOMAR_INTERNI_OPIS, SA.NAZIV1 AS ARTIKLI_NAZIV1, 
SD.KOMENTAR AS SALDKONT_KOMENTAR, SD.R_EXPORT_NR AS SALDKONT_EXPORT_NR, SD.SDK_RN_TIP AS SALDKONT_SDK_RN_TIP, SD.SDK_RN_PL AS SALDKONT_SDK_RN_PL,
SD.VRSTA_RACUNA AS SALDKONT_VRSTA_RACUNA, SD.NNLOCATION_ID AS SALDKONT_NNLOCATION_ID, SD.ID_SALDKONT_GEN AS SALDKONT_ID_SALDKONT_GEN, SD.ID_BATCH AS SALDKONT_ID_BATCH, SD.ID_EXCHANGE AS SALDKONT_ID_EXCHANGE,
SNK.SLO AS SALDKONT_KNJIZBA_SLO, SNK.INTERNI_OPIS AS SALDKONT_KNJIZBA_INTERNI_OPIS,
RD.ID_DAVEK AS RACUN_DATA_ID_DAVEK, RD.ID_STORITVE AS RACUN_DATA_ID_STORITVE, NNP.N_PRIVEZA AS M_STORITVE_N_PRIVEZA, RSD.OPIS AS RACUN_DATA_DAVEK_OPIS, NPC.PROFITNI_CENTER AS NNPC_PROFITNI_CENTER, SG.VRSTA_RACUNA AS VRSTA_RACUNA_GEN,
NPC.OPIS AS NNPC_OPIS, NPC.SIFRA AS NNPC_SIFRA, SF.PROFIT_CENTER AS SIFKONT_NNPC_SIFRA
FROM KNJIZBE KN
LEFT OUTER JOIN KUPCI KU ON KU.ID = KN.PARTNER
LEFT OUTER JOIN SIFKONT SF ON SF.CTRL = KN.KONTO
LEFT OUTER JOIN M_NNSTOMAR NS ON NS.SIFRA = KN.SIFRA_STOR
LEFT OUTER JOIN S_ARTIKLI SA ON SA.ID_ARTIKEL = KN.ID_ARTIKEL
LEFT OUTER JOIN SALDKONT SD ON SD.ID_SALDKONT = KN.ID_SALDKONT
LEFT OUTER JOIN SALDKONT SG ON SD.ID_SALDKONT_GEN = SG.ID_SALDKONT
LEFT OUTER JOIN NKNJIZBA SNK ON SNK.SALDKONT = SD.VRSTA_RACUNA
LEFT OUTER JOIN RACUN_DATA RD ON RD.ID_RACUN_DATA = KN.IDGROUP
LEFT OUTER JOIN M_STORITVE MS ON MS.ID_STORITVE = RD.ID_STORITVE
LEFT OUTER JOIN NNPRIVEZ NNP ON NNP.ID_PRIVEZ = MS.ID_PRIVEZ
LEFT OUTER JOIN S_DAVEK RSD ON RSD.ID_DAVEK = RD.ID_DAVEK
LEFT OUTER JOIN NNPC NPC ON NPC.SIFRA = KN.PROFIT_CENTER
)
;


insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2084, SYSDATE, '5.5', 2004, 'BOOKKEEPING')
;
