CREATE TABLE TIMER_LOG (
ID_TIMER_LOG NUMBER NOT NULL,
ID_TIMER_DATA NUMBER,
START_DATE DATE,
SERVER_NAME VARCHAR2(30 CHAR),
CONSTRAINT TIMER_LOG_ID_TIMER_DATA_FK FOREIGN KEY (ID_TIMER_DATA) REFERENCES TIMER_DATA(ID_TIMER_DATA),
CONSTRAINT TIMER_LOG_PK PRIMARY KEY(ID_TIMER_LOG)
);

CREATE SEQUENCE TIMER_LOG_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE INDEX IX_TIMER_LOG_ID_TIMER_DATA ON TIMER_LOG(ID_TIMER_DATA);

CREATE INDEX IX_TIMER_LOG_START_DATE_DATA ON TIMER_LOG(START_DATE);

CREATE OR REPLACE VIEW V_TIMER_LOG AS (
SELECT TL.ID_TIMER_LOG, TL.ID_TIMER_DATA, TL.START_DATE, TL.SERVER_NAME, 
TD.TIMER_ID, TD.ID_TYPE AS TIMER_ID_TYPE, TD.DESCRIPTION AS TIMER_DESCRIPTION, TD.INTERNAL_DESCRIPTION AS TIMER_INTERNAL_DESCRIPTION, TD.CREATED_BY_USER AS TIMER_CREATED_BY_USER
FROM TIMER_LOG TL
LEFT OUTER JOIN TIMER_DATA TD ON TD.ID_TIMER_DATA = TL.ID_TIMER_DATA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2140, SYSDATE, '5.5', 2060, 'Timer log')
;

