CREATE TABLE DEPARTMENT_RIGHTS (
	ID NUMBER NOT NULL,
	NDEPARTMENT VARCHAR2(20 CHAR) NOT NULL,
  PRAVICA VARCHAR2(40 CHAR) NOT NULL,
	CONSTRAINT DR_NDEPARTMENT_FK FOREIGN KEY (NDEPARTMENT) REFERENCES NDEPARTMENT(SIFRA),
	CONSTRAINT DEPARTMENT_RIGHTS_PK PRIMARY KEY (ID)
);

ALTER TABLE DEPARTMENT_RIGHTS
ADD CONSTRAINT DEPARTMENT_RIGHTS_UNIQUE
UNIQUE (NDEPARTMENT, PRAVICA);

CREATE SEQUENCE DEPARTMENT_RIGHTS_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE OR REPLACE VIEW V_DEPARTMENT_RIGHTS AS (
	SELECT DR.ID, DR.NDEPARTMENT, DR.PRAVICA, ND.OPIS AS NDEPARTMENT_OPIS, ND.INTERNI_OPIS AS NDEPARTMENT_INTERNI_OPIS,
  NR.KOMENTAR AS NRIGHTS_KOMENTAR, NR.KOMENTAR_TUJ AS NRIGHTS_KOMENTAR_TUJ, NR.INTERNI_OPIS AS NRIGHTS_INTERNI_OPIS
	FROM DEPARTMENT_RIGHTS DR
  LEFT OUTER JOIN NDEPARTMENT ND ON ND.SIFRA = DR.NDEPARTMENT
  LEFT OUTER JOIN NRIGHTS NR ON NR.PRAVICA = DR.PRAVICA
);

CREATE OR REPLACE VIEW V_RIGHTS AS (
  SELECT CONCAT(NUSER, PRAVICA) AS ID, NUSER, PRAVICA 
  FROM RIGHTS
  UNION
  SELECT CONCAT(UD.NUSER, DR.PRAVICA), UD.NUSER, DR.PRAVICA 
  FROM NUSERDEP UD, DEPARTMENT_RIGHTS DR
  WHERE UD.NDEPARTMENT = DR.NDEPARTMENT
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (769, SYSDATE, '5.5', 689, 'Department rights');