CREATE TABLE WORK_ORDER_TEMPLATE (
	ID NUMBER NOT NULL,
	DATE_FROM VARCHAR2(100 CHAR),
	DATE_TO VARCHAR2(100 CHAR),
	"COMMENT" VARCHAR2(500 CHAR),
	DATE_CREATED DATE,
	USER_CREATED VARCHAR2(50 CHAR),
	DATE_CHANGED DATE,
	USER_CHANGED VARCHAR2(50 CHAR),
	CONSTRAINT WORK_ORDER_TEMPLATE_PK PRIMARY KEY(ID)
);

ALTER TABLE WORK_ORDER_TEMPLATE
ADD STATUS NUMBER;

ALTER TABLE WORK_ORDER_TEMPLATE
ADD MATERIAL VARCHAR2(1 CHAR);

ALTER TABLE WORK_ORDER_TEMPLATE
ADD NAME VARCHAR2(100 CHAR);

CREATE SEQUENCE WORK_ORDER_TEMPLATE_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE TABLE SERVICE_TEMPLATE (
	ID NUMBER NOT NULL,
	ID_WORK_ORDER_TEMPLATE NUMBER,
	SERVICE VARCHAR2(10 CHAR),
	DATE_FROM VARCHAR2(100 CHAR),
	DATE_TO VARCHAR2(100 CHAR),
	DATE_CREATED DATE,
	USER_CREATED VARCHAR2(50 CHAR),
	DATE_CHANGED DATE,
	USER_CHANGED VARCHAR2(50 CHAR),
	CONSTRAINT SERVICE_TEMPLATE_PK PRIMARY KEY(ID),
	CONSTRAINT ST_WORK_ORDER_TEMPLATE_FK FOREIGN KEY(ID_WORK_ORDER_TEMPLATE) REFERENCES WORK_ORDER_TEMPLATE(ID)
);

ALTER TABLE SERVICE_TEMPLATE
ADD STATUS NUMBER;

CREATE SEQUENCE SERVICE_TEMPLATE_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;


CREATE TABLE ISSUE_DOCUMENT_TEMPLATE (
	ID NUMBER NOT NULL,
	ID_WORK_ORDER_TEMPLATE NUMBER,
	"DATE" VARCHAR2(100 CHAR),
	"GROUP" VARCHAR2(10 CHAR),
	"RECIPIENT" VARCHAR2(20 CHAR),
	DATE_CREATED DATE,
	USER_CREATED VARCHAR2(50 CHAR),
	DATE_CHANGED DATE,
	USER_CHANGED VARCHAR2(50 CHAR),
	CONSTRAINT ISSUE_DOCUMENT_TEMPLATE_PK PRIMARY KEY(ID),
	CONSTRAINT IDT_WORK_ORDER_TEMPLATE_FK FOREIGN KEY(ID_WORK_ORDER_TEMPLATE) REFERENCES WORK_ORDER_TEMPLATE(ID)
);

ALTER TABLE ISSUE_DOCUMENT_TEMPLATE
ADD STATUS NUMBER;

CREATE SEQUENCE ISSUE_DOCUMENT_TEMPLATE_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;


CREATE TABLE ISSUE_DOC_TRAFFIC_TEMPLATE (
	ID NUMBER NOT NULL,
	ID_ISSUE_DOCUMENT_TEMPLATE NUMBER,
	ID_ARTIKEL NUMBER,
	QUANTITY NUMBER,
	DISCOUNT NUMBER,
	MARGIN NUMBER,
	INVOICE VARCHAR2(1 CHAR),
	"COMMENT" VARCHAR2(500 CHAR),
	DATE_CREATED DATE,
	USER_CREATED VARCHAR2(50 CHAR),
	DATE_CHANGED DATE,
	USER_CHANGED VARCHAR2(50 CHAR),
	CONSTRAINT IDT_TEMPLATE_PK PRIMARY KEY(ID),
	CONSTRAINT IDT_ISSUE_DOCUMENT_TEMPLATE_FK FOREIGN KEY(ID_ISSUE_DOCUMENT_TEMPLATE) REFERENCES ISSUE_DOCUMENT_TEMPLATE(ID)
);

ALTER TABLE ISSUE_DOC_TRAFFIC_TEMPLATE
ADD STATUS NUMBER;

CREATE SEQUENCE ISSUE_DOC_TRAFFIC_TEMPLATE_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;


CREATE OR REPLACE VIEW V_WORK_ORDER_TEMPLATE AS (
  SELECT WO.ID, WO.NAME, WO.DATE_FROM, WO.DATE_TO, WO."COMMENT", WO.STATUS, WO.MATERIAL
	FROM WORK_ORDER_TEMPLATE WO
);

CREATE OR REPLACE VIEW V_SERVICE_TEMPLATE AS (
  SELECT SE.ID, SE.ID_WORK_ORDER_TEMPLATE, SE.SERVICE, SE.DATE_FROM, SE.DATE_TO, SE.STATUS, MN.OPIS AS NNSTOMAR_OPIS
	FROM SERVICE_TEMPLATE SE
  LEFT OUTER JOIN M_NNSTOMAR MN ON MN.SIFRA = SE.SERVICE 
);

CREATE OR REPLACE VIEW V_ISSUE_DOCUMENT_TEMPLATE AS (
  SELECT IST.ID, IST.ID_WORK_ORDER_TEMPLATE, IST."DATE", IST."GROUP", IST.RECIPIENT, IST.STATUS
	FROM ISSUE_DOCUMENT_TEMPLATE IST
);

CREATE OR REPLACE VIEW V_ISSUE_DOC_TRAFFIC_TEMPLATE AS (
  SELECT IDT.ID, IDT.ID_ISSUE_DOCUMENT_TEMPLATE, IDT.ID_ARTIKEL, IDT.QUANTITY, IDT.DISCOUNT, IDT.MARGIN, IDT.INVOICE, IDT."COMMENT", IDT.STATUS
	FROM ISSUE_DOC_TRAFFIC_TEMPLATE IDT
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (907, SYSDATE, '5.5', 827, 'Predloge DN');